<template>
  <span class="StopWatch">
    <span class="StopWatch--human">{{ human }}</span>
    <span class="StopWatch--precise">{{ precise }}</span>
  </span>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from 'vue'
import moment, { unitOfTime } from 'moment-timezone'

export default defineComponent({
  name: 'StopWatch',
  props: {
    start: {
      type: Object as PropType<Date | moment.Moment>,
      required: true,
    },
    now: {
      type: Object as PropType<Date | moment.Moment>,
      required: true,
    },
  },

  setup(props) {
    const duration = computed(() =>
      moment.duration(moment(props.now).diff(props.start))
    )
    return {
      human: computed(() => duration.value.humanize()),
      precise: computed(() => {
        const parts = []

        const bufferDuration = duration.value.clone()
        const units: unitOfTime.DurationAs[] = [
          'days',
          'hours',
          'minutes',
          'seconds',
        ]

        const threshold = { ss: 0, s: 60, m: 60, h: 60, d: 1000000 }

        for (const unit of units) {
          const asUnitOfTime = Math.floor(bufferDuration.as(unit))
          if (asUnitOfTime) {
            const partDuration = moment.duration(asUnitOfTime, unit)
            parts.push(partDuration.humanize(false, threshold))
            bufferDuration.subtract(partDuration)
          }
        }

        return parts.join(' ')
      }),
    }
  },
})
</script>

<style lang="scss" scoped>
.StopWatch {
  position: relative;
  white-space: pre;

  &:not(:hover) .StopWatch--precise {
    display: none;
  }

  &:hover .StopWatch--human {
    display: none;
  }
}
</style>
